﻿using System;
using System.Collections;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace Cassandra.Mapping
{
    internal class Page<T> : IPage<T>
    {
        private readonly List<T> _list;

        public byte[] CurrentPagingState { get; private set; }

        public byte[] PagingState { get; private set; }

        public int Count
        {
            get { return _list.Count; }
        }

        public bool IsReadOnly
        {
            get { return true; }
        }

        internal Page(IEnumerable<T> items, byte[] currentPagingState, byte[] pagingState)
        {
            _list = new List<T>(items);
            CurrentPagingState = currentPagingState;
            PagingState = pagingState;
        }

        public IEnumerator<T> GetEnumerator()
        {
            return _list.GetEnumerator();
        }

        IEnumerator IEnumerable.GetEnumerator()
        {
            return GetEnumerator();
        }

        public void Add(T item)
        {
            throw new NotSupportedException();
        }

        public void Clear()
        {
            throw new NotSupportedException();
        }

        public bool Contains(T item)
        {
            return _list.Contains(item);
        }

        public void CopyTo(T[] array, int arrayIndex)
        {
            _list.CopyTo(array, arrayIndex);
        }

        public bool Remove(T item)
        {
            throw new NotSupportedException();
        }
    }
}
